package com.xydl.cac.thermal;

import com.hcsdk.HCNetSDK;
import com.sun.jna.Pointer;
import com.xydl.cac.entity.NSensor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

@Service
@Slf4j
public class HCRemoteConfigCallBack implements HCNetSDK.FRemoteConfigCallBack {

    public boolean done;
    public NSensor item;
    public String time;
    public HCThermalService service;

    @Override
    public void invoke(int dwType, Pointer lpBuffer, int dwBufLen, Pointer pUserData) {
        if (done) {
            return;
        }
        try {
            HCNetSDK.NET_DVR_THERMOMETRY_UPLOAD data = new HCNetSDK.NET_DVR_THERMOMETRY_UPLOAD();
            Pointer pointer = data.getPointer();
            pointer.write(0, lpBuffer.getByteArray(0, data.size()), 0, data.size());
            data.read();
            float max, min, aver;
            if (0 == data.byRuleCalibType) {
                max = data.struPointThermCfg.fTemperature;
                min = max;
                aver = max;
                log.info("海康热成像采集到max=" + max + ", min=" + min + ", aver=" + aver);
                service.save(item.getTableName(), item.getDevId(),
                        max, min, aver, time);
                done = true;
            } else if (1 == data.byRuleCalibType || 2 == data.byRuleCalibType) {
                max = data.struLinePolygonThermCfg.fAverageTemperature;
                min = data.struLinePolygonThermCfg.fMinTemperature;
                aver = data.struLinePolygonThermCfg.fMaxTemperature;
                log.info("海康热成像采集到max=" + max + ", min=" + min + ", aver=" + aver);
                service.save(item.getTableName(), item.getDevId(),
                        max, min, aver, time);
                done = true;
            }
        } catch (Exception ex) {
            log.error("HCRemoteConfigCallBack异常", ex);
        }
    }
}
